<html id="web"><title>Come creare un semplice sito con <code>ssg5</code> &mdash; Blog di Stefano</title>
<meta charset="UTF-8">
<link rel="alternate" type="application/atom+xml" href="/rss.xml">
<link rel="stylesheet" href="/style.css">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<script src="https://code.jquery.com/jquery-3.6.0.slim.min.js" integrity="sha256-u7e5khyithlIdTpu22PHhENmPcRdFiHRjhAuHcs05RI=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/js-cookie@rc/dist/js.cookie.min.js"></script>
<script src="/n.js"></script>
<link href="https://fonts.googleapis.com/css2?family=Inconsolata:wght@300&family=Questrial&display=swap" rel="stylesheet">
<link href="https://fonts.googleapis.com/css2?family=Quicksand:wght@300&display=swap" rel="stylesheet">

<div class="topbar">
	<div class="logo-container">
		<img src="https://gitlab.com/stefano.cadringher/cadri.xyz/-/raw/master/common/images/logo.svg" height="100%">
	</div>
	<div class="menuitem">
		<a class="m" href="/index.html">Home</a>
	</div>
	<div class="menuitem">
		<a class="m" href="/contacts.html">Contatti</a>
	</div>
	<div class="menuitem">
		<a class="m" href="/articles.html">Articoli</a>
	</div>
	<div class="menuitem">
		<a class="m" target="_blank" href="https://bit.ly/cadricvit">CV</a>
	</div>
</div>
<h1>Come creare un semplice sito con <code>ssg5</code></h1>

<h3><a class=backbtn href=/articles>← Pagina precedente</a></h3>

<p><em>Ultimo aggiornamento 2020-07-03 15:13</em></p>

<blockquote>
  <p>Per la scrittura di questo articolo (e la creazione di questo sito) ho preso ispirazione da <a href="https://www.youtube.com/watch?v=N_ttw2Dihn8">questo video</a> di uno dei miei content creator preferiti. Se vuoi saperne di più su <code>ssg5</code> e tutte le sue funzionalità, <strong>ti consiglio di visitare il sito del suo creatore</strong>, linkato nel footer di ogni pagina.</p>
</blockquote>

<h2>Nozioni di base</h2>

<p><code>ssg5</code> combinato con <a href="https://kristaps.bsd.lv/lowdown/">lowdown</a> oppure <a href="https://daringfireball.net/projects/markdown/">Markdown.pl</a> essenzialmente <em>compila</em> i tuoi documenti <a href="https://en.wikipedia.org/wiki/Markdown">markdown</a> in HTML, aggiungendo un'intestazione precompilata in testa alla pagina e un footer in basso. Si può inoltre aggiungere uno <code>style.css</code> nella cartella <code>src</code>.</p>

<h2>Installazione</h2>

<h3>Download</h3>

<pre>
mkdir -p bin
curl -s https://rgz.ee/bin/ssg5 > bin/ssg5
curl -s https://rgz.ee/bin/Markdown.pl > bin/Markdown.pl
chmod +x bin/ssg5 bin/Markdown.pl
</pre>

<p>Per questa installazione andremo ad utilizzare <code>Markdown.pl</code> perchè vogliamo convertire i file <code>.md</code> in file HTML.</p>

<h3>Setup e primo avvio</h3>

<p>Devi ora assicurarti che sia <code>ssg5</code> che <code>Markdown.pl</code> siano nella variabile <code>$PATH</code>, e che le cartelle <code>src</code> e <code>dst</code> esistano e siano accessibili dall'utente desiderato. Puoi chiamare queste ultime due cartelle come vuoi. Per ragioni pratiche io ad esempio ho rinominato <code>dst</code> in <code>web</code>. </p>

<pre>
PATH="wherever/your/bin/is:$PATH"
mkdir src dst
</pre>

<p>Ora dobbiamo riempire la cartella <code>src</code> con delle pagine in markdown. Per farlo iniziamo scrivendo qualcosa in un file chiamato <code>index.md</code>, nella cartella <code>src</code>, come nell'esempio sotto:</p>

<p><img src="/images/sublime-index-markdown.png" alt="alt text" title="index.md example" /></p>

<p>Ora bisogna aggiungere un header e un footer nella cartella <code>src</code> per includere file css, aggiungere una navbar o comunque se si desidera avere degli elementi presenti in ogni pagina. Per aggiungere header e footer bisogna creare <code>_header.html</code> e <code>_footer.html</code> nella cartella <code>src</code> e riempirli con il contenuto desiderato.</p>

<h4>Il mio file <code>_header.html</code>:</h4>

<pre>
<&zwj;html><&zwj;title><&zwj;/title>
<&zwj;meta charset="UTF-8">
<&zwj;link rel="alternate" type="application/atom+xml" href="/rss.xml">
<&zwj;link rel="stylesheet" href="/style.css">
<&zwj;meta name="viewport" content="width=device-width, initial-scale=1.0">
...
</pre>

<h4>Il mio file <code>_footer.html</code>:</h4>

<pre>
<&zwj;div class="footer">
    <&zwj;div class="menuitem">
        <&zwj;a class="m" href="https://en.cadri.xyz">🇬🇧 English version<&zwj;/a> 
    <&zwj;/div>
    <&zwj;br>
    &copy; <&zwj;a href="contacts.html">Stefano Cadringher<&zwj;/a>, 2020 &mdash; Powered by a modified version of <&zwj;a href="https://www.romanzolotarev.com">Roman Zolotarev's</&zwj;a> <&zwj;a href="https://www.romanzolotarev.com/ssg.html">ssg5<&zwj;/a>
<&zwj;/div>
...
</pre>

<p>Ora basta eseguire <code>ssg5</code> con questo comando</p>

<pre>
bin/ssg5 src dst 'Test' 'http://www.yourwebsite.com'
</pre>

<p>Dove <code>bin</code> è la cartella dove <code>ssg5</code> è stato scaricato, <code>src</code> è la cartella dove metti tutti i file <code>.md</code> e <code>dst</code> la cartella di destinazione. <strong>Test</strong> sarà il nome del sito, che apparirà dopo il nome della singola pagina nella barra del titolo del browser. Puoi cambiare <strong>Test</strong> con quello che vuoi. <strong>L'ultimo parametro è richiesto</strong> se vuoi i feed RSS (non in questo tutorial) e la mappa del sito in <code>xml</code>, generata automaticamente da <code>ssg5</code>. Il comando per questo sito in versione italiana è questo, ad esempio:</p>

<pre>
bin/ssg5 src web 'Stefanos blog' 'https://en.cadri.xyz'
</pre>

<p><img src="/images/dst-folder-finder.png" alt="alt text" title="index.md example" /></p>

<h2>Ultimi passi</h2>

<p>Ok hai una pagina funzionante (spero). Bene, ora ti spiego come ho costruito <strong>questo sito</strong>. Mi serviva un livello di complessità leggermente maggiore dato che avrei dovuto scrivere questi articoli in due lingue e <strong>volevo poter condividere file statici tra pagine di entrambi i sottositi</strong>, tenendo però il numero di cartelle comprensibile e minimale sul server e sul mio computer.</p>

<h3>Folder structure</h3>

<p><img src="/images/folder-file-list.png" alt="alt text" title="index.md example" /></p>

<p>La mia soluzione è molto semplice e non ha richiesto un particolare sforzo, ma mi trovo abbastanza bene. Ho messo tutti i file che volevo fossero condivisi tra i vari siti (sono differenti <em>virtual server</em> su nginx) in una cartella chiamata <code>common</code>. Ho poi scritto un semplice script per "compilare" sia la versione in inglese che quella in italiano con <code>ssg5</code>, così:</p>

<pre>
#!/bin/sh
PATH="$HOME/Documents/Website/bin:$PATH"
./bin/ssg5 it/src it/web 'Blog di Stefano' 'https://it.cadri.xyz'
./bin/ssg5 en/src en/web 'Stefanos blog' 'https://en.cadri.xyz'
cp -R common/* it/web/
cp -R common/* en/web/

scp -r it/web/* webserveruser@cadri.xyz:/srv/web/it
scp -r en/web/* webserveruser@cadri.xyz:/srv/web/en
</pre>

<p>Come puoi vedere, compilo il mio sito dalla cartella <code>src</code> di ogni lingua, e una volta compilata in locale nella cartella <code>web</code>, copio i contenuti statici all'interno di ognuna delle cartelle <code>web</code>, facendo sì che i link all'interno dei file html rimangano relativi alla cartella in cui sono contenuti. Carico le cartelle web su questo server usando <code>scp</code> con chiavi ssh condivise, per tenere tutto sicuro.</p>

<pre>
$ tree
.
|-- en
|   |-- articles
|   |   |-- how-to-build-a-website.html
|   |   `-- the-url-shortener-story.html
|   |-- articles.html
|   |-- contacts.html
|   |-- favicon.ico
|   |-- images
|   |   |-- dst-folder-finder.png
|   |   |-- favicon.ico
|   |   |-- folder-file-list.png
|   |   |-- logo.svg
|   |   |-- sublime-index-markdown.png
|   |   `-- website-folder-finder.png
|   |-- index.html
|   |-- logo.svg
|   |-- sitemap.xml
|   `-- style.css
`-- it
    |-- articles
    |   `-- the-url-shortener-story.html
    |-- articles.html
    |-- contacts.html
    |-- favicon.ico
    |-- images
    |   |-- dst-folder-finder.png
    |   |-- favicon.ico
    |   |-- folder-file-list.png
    |   |-- logo.svg
    |   |-- sublime-index-markdown.png
    |   `-- website-folder-finder.png
    |-- index.html
    |-- logo.svg
    |-- sitemap.xml
    `-- style.css

6 directories, 29 files
</pre>

<p>struttura delle cartelle sul server al momento della scrittura.</p>
<div class="footer">
	<div class="menuitem">
		<a class="m" href="https://en.cadringher.dev">🇬🇧 English version</a> 
		<a class="m" style="cursor: pointer;"onclick="toggleNightMode()">✨ Modalità notte</a> 
	</div>
	<br><br>
	&copy; <a href="contacts.html">Stefano Cadringher</a> @ Nacheso Software, 2021 &mdash; P.IVA: 11328220964<br>
	Powered by a modified version of <a href="https://www.romanzolotarev.com">Roman Zolotarev's</a> <a href="https://www.romanzolotarev.com/ssg.html">ssg5</a>
</div>
